=== debian/changelog ===
lenmus (5.6.2-0.1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Bump up to debhelper 10.
  * Switch to modern tiny dh rules file.
  * Drop unneccessary build-deps.
  * Change package name to just "lenmus".

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 03 Feb 2021 14:06:22 -0800

lenmus (5.6.2-0~202004181712~ubuntu18.04.1) bionic; urgency=low

  * Auto build.

 -- Cecilio Salmeron <s.cecilio@gmail.com>  Sat, 18 Apr 2020 17:30:19 +0000

lenmus (5.6.2) stable; urgency=low

  * Latest release

 -- Cecilio Salmeron <s.cecilio@gmail.com>  Sat, 18 Apr 2020 17:54:03 +0200
