=== debian/control ===
Source: lenmus
Section: education
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Maintainer: Cecilio Salmeron <s.cecilio@gmail.com>
Standards-Version: 3.9.3
Homepage: http://www.lenmus.org/
Build-Depends: cmake (>= 3.1),
               debhelper (>= 10),
               fluid-soundfont-gm,
               libfluidsynth-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libpng++-dev,
               libportmidi-dev,
               libsqlite3-dev (>=3.6.10),
               libwxgtk3.0-dev (>= 3.0),
#               lsb-release,
               pkg-config,
               wx-common,
               zlib1g (>= 1:1.2.1)

Package: lenmus
Architecture: any
Depends: fluid-soundfont-gm, ${misc:Depends}, ${shlibs:Depends}
Description: A program for aural training and to learn music theory
 LenMus Phonascus is a FLOSS program for studying music theory that allows
 you to focus on specific skills and exercises, on both theory and aural
 training. The different activities can be customized to meet your needs.
 LenMus Phonascus allows you to work at your own pace, providing interactive
 feedback until mastery of each concept is achieved.
 .
 LenMus Phonascus aims to create, as a community, the best free program for
 music students, to help them in their studies. LenMus Phonascus has no
 commercial purposes.
